﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using DividendGraph.Types;
using DividendGraph.Manager.Interface;
using DividendGraph.Manager.Concrete;

namespace DividendGraph.Web
{
    public class DividendService : IDividendService
    {
        #region IDividendService Members

        public List<Dividend> GetDividends(string ticker, bool useTestData)
        {
            // Get dividends for the past 5 years.
            DateTime startDate = DateTime.Now - TimeSpan.FromDays(1825);
            Range range = new Range(startDate.Month, startDate.Year, DateTime.Now.Month, DateTime.Now.Year);

            // Select the actual web repository or a test repository.
            IRepository repository = GetRepository(useTestData);

            // Make the call to get the dividends.
            return repository.GetByRange(ticker, range);
        }

        private IRepository GetRepository(bool useTestData)
        {
            IRepository repository = null;

            // If using test data, use the TestRepository. Otherwise, use the actual web repository.
            if (useTestData)
            {
                repository = new TestRepository();
            }
            else
            {
                repository = new YahooRepository();
            }

            return repository;
        }

        #endregion
    }
}
